{% extends "template/app.twig" %}

{% block meta %}
    {% set meta = {'keywords': 'Oportunidades'} %}
    {{ parent() }}
{% endblock %}

{% block link %}
    {{ parent() }}
{% endblock %}

{% block header %}
    {{ parent() }}
{% endblock %}

{% block aside %}
    {{ parent() }}
{% endblock %}

{% block content %}
    {{ parent() }}
    {% include "template/partial/section/setting_opportunity_origin.twig" %}
{% endblock %}

{% block footer %}
    {{ parent() }}
{% endblock %}

{% block script %}
    {{ parent() }}

    <script>
        $(document).ready(function () {

            //Selection
            var gridClient = $("#data-table-opportunity-origin").bootgrid({
                css: {
                    icon: 'zmdi icon',
                    iconColumns: 'zmdi-view-module',
                    iconDown: 'zmdi-expand-more',
                    iconRefresh: 'zmdi-refresh',
                    iconUp: 'zmdi-expand-less'
                },
                templates: {
                    header: ""
                },
                selection: false,
                multiSelect: false,
                rowSelect: false,
                keepSelection: false,
                statusMappings: {
                    4: "bgm-bluegray",
                    5: "bgm-pink"
                },
                formatters: {
                    "commands": function (column, row) {
                        return "<button type=\"button\" class=\"btn btn-icon command-edit waves-effect waves-circle lo-e\" title=\"Editar origen de oportunidad\"  data-id=\"" + row.id + "\" data-name=\"" + row.name + "\"><span class=\"zmdi zmdi-edit\"></span></button> " +
                                "<button type=\"button\" class=\"btn btn-icon command-delete waves-effect waves-circle lo-d\" title=\"Eliminar origen de oportunidad\" data-id=\"" + row.id + "\"><span class=\"zmdi zmdi-delete\"></span></button>";
                    }
                }
            }).on("loaded.rs.jquery.bootgrid", function () {
                gridClient.find(".lo-e").on("click", function (e) {

                    var id = $(this).data("id");
                    var name = $(this).data("name");
                    $('#modalOpportunityOrigin').find('.modal-title:first').text('Actualizar Origen de oportunidad');
                    $('#form-new-opportunity-origin').attr('data-action', 'put');
                    $('#opportunity_origin_id').val(id);
                    $('#opportunity_origin_name').val(name);
                    
                    $('#modalOpportunityOrigin').modal('show');
                });

                gridClient.find(".lo-d").on("click", function (e) {
                    var id = $(this).data("id");

                    swal({
                        title: "¿Está seguro de eliminar el Origen de oportunidad?",
                        text: "Se perderan todos los datos ingresados!",
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        confirmButtonText: "Borrar",
                        cancelButtonText: "Cancelar",
                        closeOnConfirm: true
                    }, function (isConfirm) {
                        if (isConfirm) {
                            $.ajax({
                                type: "DELETE",
                                url: '{{path_for('opportunity-origin-delete')}}',
                                data: {opportunity_origin_id: id},
                                dataType: "JSON",
                                success: function (data) {
                                    console.log(data);
                                    if (data.type > 1) {
                                        notify(data.message, 'success');
                                        setTimeout(function () {
                                            window.location.reload();
                                        }, 300);
                                    } else {
                                        notify(data.message, 'warning');
                                    }
                                },
                                error: function (data) {
                                    console.log(data);
                                    notify('Ha ocurrido un error, por favor intente de nuevo!', 'warning');
                                }
                            });
                        }
                    });
                });
            });

            //save
            $(document).on('click', '.save-opportunity-origin', function () {
                var type = $("#form-new-opportunity-origin").data('action');
                                
                if (isCheckSave()) {
                    $.ajax({
                        type: type,
                        url: (type === 'put') ? '{{path_for('opportunity-origin-update')}}' : '{{path_for('opportunity-origin-create')}}',
                        data: $('#form-new-opportunity-origin').serializeArray(),
                        dataType: "JSON",
                        success: function (data) {
                            console.log(data);
                            if (data.type > 1) {
                                notify(data.message, 'success');
                                setTimeout(function () {
                                    window.location.reload();
                                }, 300);
                            } else {
                                notify(data.message, 'warning');
                            }
                        },
                        error: function (data) {
                            console.log(data);
                            notify('Ha ocurrido un error, por favor intente de nuevo!', 'warning');
                        }
                    });
                } else {
                    $('#modal-msg').html('\
                        <div class="alert alert-warning alert-dismissible" role="alert">\n\
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">\n\
                                <span aria-hidden="true">×</span>\n\
                            </button>\n\
                            Completá los campos resaltados\n\
                        </div>'
                    ).show('slow');
                }
            });

            //check form
            var isCheckSave = function () {
                var is = true;
                
                if ($('#opportunity_origin_name').val() === '') {
                    $('#opportunity_origin_name').parents('.fg-line').addClass('has-error');
                    is = false;
                }
                return is;
            };
            
            $('#modalOpportunityOrigin').on('hidden.bs.modal', function () {
                /*
                $.each($('#brands option'), function(){
                    $(this).removeAttr('selected');
                });
                $('#brands').trigger('chosen:updated');
                */
                $('#opportunity_origin_name').val('');
                $('#opportunity_origin_name').parents('.fg-line').removeClass('has-error');
            });
            
            $(document).on('blur', '#opportunity_origin_name', function () {
                if ($(this).val() !== '') {
                    $(this).parents('.fg-line').removeClass('has-error');
                    $('#modal-msg').hide('slow');
                }
            });
            
            $(document).on('click', '#create-opportunity-origin', function () {
                $('#form-new-opportunity-origin').attr('data-action', 'post');
                $('#modalOpportunityOrigin').find('.modal-title:first').text('Nuevo Origen de oportunidad');
            });
        });
    </script>

{% endblock %}